/******************************(spi_Mem3.c)***************
 *	SPIڑ(25LC1024/23LCV1024)ǂݏCu
 ***********************************************************/

#include <stdlib.h>
#include <stdio.h>
//#include "mcc_generated_files/mcc.h"
//#include "spi_Mem2.h"
//#include "AQM1248A_v2.h"
#include "myProject.h"
#define MBFSIZE	130                      // pobt@[TCY

//=== O[oϐ ============
char     Dlm[] = ",";                   // ؂f~^
char     SBuf[20];                      // 񏈗pobt@[

//--- SPI[p
//static uint8_t  BlkNum = 0;             // ubNԍ
static uint32_t CrtAdr = 0;             // JgAhX
static uint8_t  DBuf[MBFSIZE];          // y[Wpobt@[
static uint8_t  SqMode = 0;             // V[PX[htO
static char     lstCmd;                 // ŏIR}h
static uint8_t  spiRom = 1;             // spiRomǂ

//static char     kFnt[32];

/*************************************
 *  SPIC EEPROM function
 **************************************/

//---- ROMXe[^X̓ǂݏo
uint8_t SPI_Rom_RdStat(){           // ROM̂ݎgp
	uint8_t stat;
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_RD_STATS);
	stat = SPI1_ExchangeByte(0xAA);	// 0xAA̓_~[
	CS0_SetHigh();
	return stat;
}

//---- R}h24rbgAhX𑗐M 
void sendAdr(uint8_t cmd, uint32_t adr){
    if(spiRom) CS0_SetLow();		// spiRom(25LC1024)I
    else       CS1_SetLow();		// spiRam(23LCV1024)I
	SPI1_ExchangeByte(cmd);			// send Command
	SPI1_ExchangeByte((uint8_t)(adr>>16));
	SPI1_ExchangeByte((uint8_t)(adr>>8));
	SPI1_ExchangeByte((uint8_t)adr);
} 
 
//-----  AhXadrA1oCgǂݏo
uint8_t SPI_Mem_Read(uint32_t adr){
	uint8_t dat;
    if(adr < 0x80000) spiRom = 1;	// spiRom(25LC1024)w
    else              spiRom = 0;	// spiRam(23LCV1024)w
	sendAdr(SPIMEM_READcmd,adr);    // send Read_CMD & Address
	dat = SPI1_ExchangeByte(0xAA);
    if(spiRom) CS0_SetHigh();		// spiRom̏ꍇ
    else       CS1_SetHigh();		// spiRam̏ꍇ
	return dat;
}

//-----  AhXadrɁA1oCgdt
uint8_t SPI_Mem_Write(uint32_t adr, uint8_t dat){
    if(adr < 0x80000){
        spiRom = 1;	// spiRom(25LC1024)w
        CS0_SetLow();
        SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
        CS0_SetHigh();
    }else              spiRom = 0;	// spiRam(23LCV1024)w   
	sendAdr(SPIMEM_WRITEcmd,adr);   // send Write_CMD & Address
	SPI1_ExchangeByte(dat);
    if(spiRom){						// spiRom̏ꍇ
		CS0_SetHigh();
		__delay_ms(6);
    }else{							// spiRam̏ꍇ
		CS1_SetHigh();
	}
    return dat;
}

//-----  AhXadr炎oCgary[]ɓǂݏo
void SPI_Mem_NRead(uint32_t adr,uint8_t *ary,uint16_t cnt){
    if(adr < 0x80000) spiRom = 1;	// spiRom(25LC1024)w
    else              spiRom = 0;	// spiRam(23LCV1024)w
	sendAdr(SPIMEM_READcmd,adr);    // send Read_CMD & Address
	SPI1_ReadBlock(ary,cnt);        // block read
	if(spiRom){
		CS0_SetHigh();
    	while(SPI_Rom_RdStat() & 1);
    }else{
		CS1_SetHigh();
	}    
}

//-----  AhXadrary[]noCg
void SPI_Mem_NWrite(uint32_t adr,uint8_t *ary,uint16_t cnt){
    if(adr < 0x80000){
        spiRom = 1;	// spiRom(25LC1024)w
        CS0_SetLow();
        SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
        CS0_SetHigh();
    }else{
        spiRom = 0;	// spiRam(23LCV1024)w
    }
    sendAdr(SPIMEM_WRITEcmd,adr);   // send Write_CMD & Address
	SPI1_WriteBlock(ary,cnt);	//  block write
	if(spiRom){
		CS0_SetHigh();
    	while(SPI_Rom_RdStat() & 1);
    }else{
		CS1_SetHigh();
	}
}

/****** ėpTu[`@********************/
//---- y[Wobt@[vg
void prt_PBf(){
    uint8_t i;
    for(i = 0; i < 128; i++){            // 164\
        #ifdef VBA
            if(i % 16 == 0) printf("\r");
        #else
            if(i % 16 == 0) printf("\n\r");
        #endif
        printf(" %02X",DBuf[i]);
    }
    puts("\r");
}

//---- 16i10iɕϊ
uint32_t my_xtoi(char *str){
    uint32_t dec;
    dec = strtoul(str,NULL,16);
    return (uint32_t)dec;
}

/************************************
 * 	R}hANV
 ************************************/
//----- vR}h   W[aaaa][,[d0,[,]]]
uint16_t spiMem_cmd_W(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  last;                      // ̍Ō̈ʒu
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt = 0;                    // ރoCgf[^
    uint16_t cnt = 0;                   // ۂɏ񂾃oCg

    lstCmd = str[0];
    if(strlen(str)==1){                 // 'W'݂̂Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        return 0;                       // f[^͏܂Ȃ
    }
    last = (uint8_t)strlen(str)-1;      // ̍sʒu擾
    if(str[last] == ','){               // sR}Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        str[last]='\0';                 // s̃R}
    }
    if(str[1]!=','){                    // 2R}H
        pt = strtok(str+1,Dlm);         // R}h̎
        if(pt != NULL){                 // AhXf[^
            res = my_xtoi(pt);
            CrtAdr = res;
        }
        pt = strtok(NULL,Dlm);          // 捞
    }else{
        pt = strtok(str+1,Dlm);         // 捞
    } 
    do{
        if(pt != NULL){                 // f[^邩H
            res = my_xtoi(pt);
            dt = (uint8_t)res;
 
            if(lstCmd=='W'){
                SPI_Mem_Write(CrtAdr,dt);   // f[^
            }else if(lstCmd == 'S'){
                DBuf[CrtAdr & 0x7F]= dt;  
            }
            sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
            #ifdef VBA
                printf("%s\r",SBuf);
            #else
                printf("%s\n\r",SBuf);
            #endif
            prtHstr_LnClr(0,16,SBuf);
            CrtAdr++; cnt++;          
            pt = strtok(NULL,Dlm);      // 
        }
    }while(pt != NULL);                 // f[^邾JԂ
    return cnt;                         // 񂾕Ԃ
}

//---- qR}h  R[aaaa][,n]
uint16_t spiMem_cmd_R(char *str){
    char *pt;                           // 񑀍p|C^
    uint16_t n = 1;                     // w肳ꂽǍoCg
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt;                        // ǂݍ񂾃oCgf[^
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg
    uint16_t i;                         // [vϐ
    
    lstCmd = str[0];
    if(strlen(str) > 1){
        if(str[1]==','){
            pt = strtok(str+2,Dlm);
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }else{
            pt = strtok(str+1,Dlm);
            if(pt != NULL){             // address?
                res = my_xtoi(pt);
                CrtAdr = res;
            }
            pt = strtok(NULL,Dlm);      // 
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }
    }
    for(i = 0; i < n; i++ ){
        dt = SPI_Mem_Read(CrtAdr);      // f[^ǂݏo
        sprintf(SBuf,"%05lX > %02X",CrtAdr,dt);
        #ifdef VBA
        	printf("%s\r",SBuf);
        #else
        	printf("%s\n\r",SBuf);
        #endif
        prtHstr_LnClr(0,16,SBuf);
        CrtAdr++; cnt++;
    }
    SqMode = 0;
    return cnt;                         // ǂݍ񂾃f[^Ԃ
}

//---- WSQ iA[hj
uint16_t spiMem_cmd_WSQ(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  dt;                        // ރoCgf[^
    uint32_t res;                       // Hexlϊ
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg

    pt = strtok(str,Dlm);
    while(pt != NULL){                  // f[^邾JԂ
        res = my_xtoi(pt);
        dt = (uint8_t)res;
        if(lstCmd == 'W'){
            SPI_Mem_Write(CrtAdr,dt);       // f[^
        }else if(lstCmd=='S'){
			DBuf[CrtAdr & 0x7F]= dt;  
        }
        sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
        #ifdef VBA
        	printf("%s\r",SBuf);
        #else
        	printf("%s\n\r",SBuf);
        #endif
        prtHstr_LnClr(0,16,SBuf);
        CrtAdr++; cnt++;
        pt = strtok(NULL,Dlm);          // 
    }
    return cnt;                         // 񂾃f[^Ԃ
}

//---- pR}hiA[h̉j   Q
void spiMem_cmd_Q(char *str){
    lstCmd = str[0];
	SqMode = 0;
	#ifndef VBA
		puts("SqMode OFF\r");
	#endif
}

//---- t(dump)R}h    U[aaaa]
//         i64oCg̃f[^DBuf[]ɓǂݏo)
int spiMem_cmd_U(char *str){
    char    *pt;                        // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    pt = strtok(str+1,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFF80;               // 128oCgPʂ 
    SPI_Mem_NRead(ad, DBuf, 128);          // 128oCgDBuf[]ɓǏo
    sprintf(SBuf,"%05lX - %05lX", ad, ad+127);
    #ifdef VBA
      	printf("%s",SBuf);
    #else
       	printf("%s\r",SBuf);
    #endif
    prtHstr_LnClr(0,16,SBuf);
    prt_PBf();
    SqMode = 0;
    return 0;
}

//---- o(Page)R}h    PW[aaaa]
//          iDBuf[]64oCgɏށj
int spiMem_cmd_P(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    if(strlen(str)==1){
        printf("PageBuffer");
        prt_PBf();
        return 0;
    }
    if(str[1]=='R'){
        spiMem_cmd_U(str+1);
        return 0;
    }
    if(str[1] != 'W') return -1;        // 2vH
    pt = strtok(str+2,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFF80;              // 128oCgPʂ
    SPI_Mem_NWrite(ad,DBuf,128);         // DBuf[]128oCg
    sprintf(SBuf,"PW:%05lX - %05lX",ad,ad+127);
    #ifdef VBA
      	printf("%s\r",SBuf);
    #else
       	printf("%s\n\r",SBuf);
    #endif    
    prtHstr_LnClr(0,16,SBuf);
    SqMode = 0;    
    return 0;
}

//----  V[PX[h̊mF
uint8_t spiMem_SqMode(){
	return SqMode;
}

//---- K(j\R}h  K[H]n 
int spiMem_cmd_K(char *str){
    char     *kp;                       // 񑀍p|C^
    uint8_t i;
    kp = (char *)DBuf;
    if(str[1] == 'H'){                  // 2HH
        for(i = 0; i < 8; i++){
            gLCD_nk16X(8*i,32,kp+16*i,8);
        }
    }else{
        for(i = 0;i < 4; i++){
            gLCD_nk16X(16*i,32,kp+32*i,16);
        }      
    }
    SqMode = 0;
    return i;
}
/******* End of File ********/
